// ---------------------------------------------------
//  CGI -     Web
// 
// (c)  , 1997
//
// E-mail: frolov@glas.apc.org
// Web:    http://www.glasnet.ru/~frolov
//         http://www.dials.ccas.ru/frolov
// ---------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void DecodeStr(char *szString);
char DecodeHex(char *str);

void main(int argc, char *argv[])
{
  int lSize;
  FILE * fileGuestBook;
  char * szMethod;
  char szBuf[1024];
  char szSrcBuf[1024];
  char szTemp[1024];
  char * szPtr;
  char * szPtrValue;
  char * szParam;

  printf("Content-type: text/html\n\n");
  printf("<!DOCTYPE HTML PUBLIC \"-//"
    "W3C//DTD HTML 3.2//EN\">");
  printf("<HTML><HEAD><TITLE> "
    "</TITLE></HEAD><BODY BACKGROUND=\"bkg.gif\">");
  printf("<H2>  </H2>");
    
  fileGuestBook = fopen("guestbk.dat", "r");
  if(fileGuestBook != NULL)
  {
    while(!feof(fileGuestBook))
    {
      fgets(szBuf, 1024, fileGuestBook);
      if(ferror(fileGuestBook))      
        break;
      fputs(szBuf, stdout);
    }
    fclose(fileGuestBook);
  }
 
  szMethod = getenv("REQUEST_METHOD");
  if(!strcmp(szMethod, "POST"))
  {
    lSize = atoi(getenv("CONTENT_LENGTH"));
    fread(szBuf, lSize, 1, stdin);

    fileGuestBook = fopen("guestbk.dat", "a+");
    printf("<HR>");
    fwrite("<HR>", 4, 1, fileGuestBook);

    szBuf[lSize] = '\0'; strcpy(szSrcBuf, szBuf);
    DecodeStr(szSrcBuf);
    szBuf[lSize] = '&'; szBuf[lSize + 1] = '\0';

    szParam = szBuf; szPtr = strchr(szParam, '&');
    if(szPtr != NULL)
    {
      *szPtr = '\0'; DecodeStr(szParam);
      szPtrValue = strchr(szParam, '='); szPtrValue++;
      printf("<A HREF=\"mailto:%s\">%s</A><BR>", 
        szPtrValue, szPtrValue);
      sprintf(szTemp, "<A HREF=\"mailto:%s\">%s</A><BR>", 
        szPtrValue, szPtrValue);
      fwrite(szTemp, strlen(szTemp), 1, fileGuestBook);
    }

    szParam = szPtr + 1; szPtr = strchr(szParam, '&');
    if(szPtr != NULL)
    {
      *szPtr = '\0'; DecodeStr(szParam);
      szPtrValue = strchr(szParam, '='); szPtrValue++;
      printf("<ADDRESS><B>%s, ", szPtrValue);
      sprintf(szTemp, "<ADDRESS><B>%s, ", szPtrValue);
      fwrite(szTemp, strlen(szTemp), 1, fileGuestBook);
    }

    szParam = szPtr + 1; szPtr = strchr(szParam, '&');
    if(szPtr != NULL)
    {
      *szPtr = '\0'; DecodeStr(szParam);
      szPtrValue = strchr(szParam, '='); szPtrValue++;
      printf("%s</ADDRESS></B>", szPtrValue);
      sprintf(szTemp, "%s</ADDRESS></B>", szPtrValue);
      fwrite(szTemp, strlen(szTemp), 1, fileGuestBook);
    }

    szParam = szPtr + 1; szPtr = strchr(szParam, '&');
    if(szPtr != NULL)
    {
      *szPtr = '\0'; DecodeStr(szParam);
      szPtrValue = strchr(szParam, '='); szPtrValue++;
      printf("<P>%s", szPtrValue);
      sprintf(szTemp, "<P>%s", szPtrValue);
      fwrite(szTemp, strlen(szTemp), 1, fileGuestBook);
    }

    printf("</BODY></HTML>");
    fclose(fileGuestBook);
    return;
  }
}

void DecodeStr(char *szString)
{
  int src;
  int dst;
  char ch;
  for(src=0, dst=0; szString[src]; src++, dst++)
  {
    ch = szString[src];
    ch = (ch == '+') ? ' ' : ch;
    szString[dst] = ch;
    if(ch == '%')
    {
      szString[dst] = DecodeHex(&szString[src + 1]);
      src += 2;
    }
  }
  szString[dst] = '\0';
}

char DecodeHex(char *str)
{
  char ch;
  if(str[0] >= 'A')
    ch = ((str[0] & 0xdf) - 'A') + 10;
  else
    ch = str[0] - '0';
  ch <<= 4;
  if(str[1] >= 'A')
    ch += ((str[1] & 0xdf) - 'A') + 10;
  else
    ch += str[1] - '0';
  return ch;
}
